# Wczytanie danych ekonometrycznych z pakietu STATA. Wymiar X:   4877 x 20.
# Nazwy zmiennych (zmienna zalezna jest ostatnia):
# [1] "stateur"  "statemb"  "state"    "age"      "tenure"   "slack"
# [7] "abol"     "seasonal" "nwhite"   "school12" "male"     "smsa"
#[13] "married"  "dkids"    "dykids"   "yrdispl"  "rr"       "rr2"
#[19] "head"     "y"
  
library(foreign); X=read.dta("benefits.dta") 
Xmat=as.matrix(X[,-20]); y=as.vector(X[,20])

mm=glm(y~Xmat,family="binomial")
print(summary(mm))

par(mfrow=c(1,2))  ###############

betaTx=cbind(1,Xmat)%*%mm$coeff
plot(betaTx,mm$fitt,pch=".",ylim=c(0,1))
points(betaTx,y,col=ifelse(y==1,2,3),pch=".")
abline(h=.5, lty=2)
abline(v=betaTx[which(abs(mm$fit-.5)==min(abs(mm$fit-.5)))], lty=2)

bw.pp=function(x) mean( c( bw.SJ(x,method="dpi"), bw.SJ(x,method="ste"), 
                           bw.bcv(x), bw.ucv(x) ), trim=.5 )

q1=sum(y)/length(y); q0=1-q1 # q1 = 0.68
N=2048; dd=density(betaTx,bw=bw.pp(betaTx),n=N); cc=range(dd$x)
dd1=density(betaTx[y==1],bw=bw.pp(betaTx[y==1]),
                         from=cc[1],to=cc[2],n=N); p1=dd1$y/sum(dd1$y)
dd0=density(betaTx[y==0],bw=bw.pp(betaTx[y==0]),
                         from=cc[1],to=cc[2],n=N); p0=dd0$y/sum(dd0$y)
#postscript("benefits.eps", onefile=FALSE, horizontal=FALSE, pointsize=10)
matplot(dd$x, cbind(p1*q1,p0*q0), xlab="betaTx", ylab="p(y,betaTx)",
                                  lty=1, type="l",col=2:3)
legend(150,0.015, c("na zasilku","bez zasilku"), col=2:3, lty=1)
p1b=p1[dd$x>-.5 & dd$x<.5]; p0b=p0[dd$x>-.5 & dd$x<.5]
xb=dd$x[dd$x>-.5 & dd$x<.5]
abline(v = xb[ abs(p1b*q1-p0b*q0) == min(abs(p1b*q1-p0b*q0)) ], lty=2)

par(mfrow=c(1,1)) ##############